## ignition-cmake2 2.1.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-cmake2 VERSION 2.1.1)

#--------------------------------------
# Initialize the IGNITION_CMAKE_DIR variable with the location of the cmake
# directory that sits next to this find-module.
set(IGNITION_CMAKE_DIR "${CMAKE_CURRENT_LIST_DIR}/cmake")

#--------------------------------------
# Add the location of this package's cmake directory to the CMAKE_MODULE_PATH
list(APPEND CMAKE_MODULE_PATH "${IGNITION_CMAKE_DIR}")

#--------------------------------------
# include the master IgnCMake module
include(IgnCMake)

#--------------------------------------
# Set up the project
ign_configure_project()

#--------------------------------------
# Install the ignition documentation files
# Note: This is not actually creating a doc target for ign-cmake; this is just
# installing files that are useful for generating the documentation of other
# ignition projects.
add_subdirectory(doc)

#--------------------------------------
# Install the benchmark files
install(DIRECTORY benchmark/
        DESTINATION ${IGN_DATA_INSTALL_DIR}/benchmark)

#--------------------------------------
# Install the codecheck files
install(DIRECTORY codecheck/
        DESTINATION ${IGN_DATA_INSTALL_DIR}/codecheck)


#============================================================================
# Configure the package to be installed
#============================================================================

#--------------------------------------
# Create configuration and installation variables
set(ign_config_input  "${CMAKE_CURRENT_SOURCE_DIR}/config/ignition-cmake-config.cmake.in")
set(ign_config_output "${PROJECT_NAME_LOWER}-config.cmake")
set(ign_version_output "${PROJECT_NAME_LOWER}-config-version.cmake")
set(ign_config_install_dir "${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME_LOWER}")
set(ign_pkgconfig_input "${CMAKE_CURRENT_SOURCE_DIR}/config/ignition-cmake.pc.in")
set(ign_pkgconfig_output "${CMAKE_BINARY_DIR}/ignition-cmake${PROJECT_VERSION_MAJOR}.pc")
set(ign_utilities_target ${PROJECT_EXPORT_NAME}-utilities)
set(ign_utilities_import_target_name ${PROJECT_EXPORT_NAME}::${ign_utilities_target})
set(ign_utilities_target_output_filename "${ign_utilities_target}-targets.cmake")
set(simple_utilities_import_name ${PROJECT_EXPORT_NAME}::utilities)

#--------------------------------------
# Configure and install the config file
configure_package_config_file(
  ${ign_config_input}
  ${ign_config_output}
  INSTALL_DESTINATION ${ign_config_install_dir}
  PATH_VARS IGN_DATA_INSTALL_DIR
  NO_CHECK_REQUIRED_COMPONENTS_MACRO)

#--------------------------------------
# Configure and install the version file
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/${ign_version_output}
  VERSION "${PROJECT_VERSION_FULL_NO_SUFFIX}"
  COMPATIBILITY SameMajorVersion)

install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${ign_config_output}
    ${CMAKE_CURRENT_BINARY_DIR}/${ign_version_output}
  DESTINATION ${ign_config_install_dir}
  COMPONENT cmake)

#--------------------------------------
# Configure and install the pkgconfig file (needed for utilities headers)
configure_file(${ign_pkgconfig_input} ${ign_pkgconfig_output} @ONLY)

install(
  FILES ${ign_pkgconfig_output}
  DESTINATION ${IGN_LIB_INSTALL_DIR}/pkgconfig
  COMPONENT pkgconfig)

#============================================================================
# Create and install the utilities component
#============================================================================
add_library(${ign_utilities_target} INTERFACE)
target_include_directories(${ign_utilities_target}
  INTERFACE
    $<INSTALL_INTERFACE:${IGN_INCLUDE_INSTALL_DIR_FULL}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>)

# Export and install the interface target
install(
  TARGETS ${ign_utilities_target}
  EXPORT ${ign_utilities_target}
  COMPONENT interface)

export(
  EXPORT ${ign_utilities_target}
  FILE ${ign_utilities_target_output_filename}
  NAMESPACE ${PROJECT_EXPORT_NAME}::)

install(
  EXPORT ${ign_utilities_target}
  DESTINATION ${ign_config_install_dir}
  FILE ${ign_utilities_target_output_filename}
  NAMESPACE ${PROJECT_EXPORT_NAME}::)

# Install the header directory
# Note: The trailing slash after "include" is necessary
install(
  DIRECTORY include/
  DESTINATION ${IGN_INCLUDE_INSTALL_DIR_FULL}
  COMPONENT headers)

#============================================================================
# Install the files for this package
#============================================================================
set(ign_modules_install_dir "${ign_config_install_dir}/cmake${PROJECT_VERSION_MAJOR}")

file(GLOB modules "cmake/*.cmake")
file(GLOB templates "cmake/*.in")

install(
  FILES ${modules} ${templates}
  DESTINATION ${ign_modules_install_dir}
  COMPONENT modules)

file(GLOB pkgconfig_templates "cmake/pkgconfig/*.in")

install(
  FILES ${pkgconfig_templates}
  DESTINATION ${ign_modules_install_dir}/pkgconfig
  COMPONENT modules)

message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")

include(CTest)
if (BUILD_TESTING)
  add_subdirectory(test)

  #============================================================================
  # Build examples
  #============================================================================
  # Do a fake install of ign-cmake in order to test the examples.
  # Copy or symlink the config.cmake files and cmake folder
  set(FAKE_BUILD_DIRECTORY "${CMAKE_BINARY_DIR}/fake/build")
  set(FAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/fake/install")

  file(MAKE_DIRECTORY ${FAKE_BUILD_DIRECTORY})
  file(MAKE_DIRECTORY ${FAKE_INSTALL_PREFIX})

  include(ExternalProject)
  ExternalProject_Add(
    FAKE_INSTALL

    SOURCE_DIR "${CMAKE_SOURCE_DIR}"
    # BUILD_ALWAYS needed since cmake doesn't notice when
    # example files change.
    # See alternate approach in a2113e0997c9 if this becomes too slow
    BUILD_ALWAYS 1
    CMAKE_ARGS
      "-DBUILD_TESTING=OFF"
      "-DCMAKE_INSTALL_PREFIX=${FAKE_INSTALL_PREFIX}"
  )

  add_subdirectory(examples)
endif()

=== doc/CMakeLists.txt ===
install(DIRECTORY doxygen/
        DESTINATION ${IGN_DATA_INSTALL_DIR}/doxygen)

=== examples/CMakeLists.txt ===
include(ExternalProject)

# test multiple build types
set(build_types Release RelWithDebInfo Debug)
find_program(EXAMPLE_LCOV_PATH lcov)
if (NOT WIN32 AND EXAMPLE_LCOV_PATH)
  list(APPEND build_types Coverage)
endif()

set(example_directories
  ign_configure_build
  prerelease
  core_no_deps
  core_child
  component_deps
  )
if (NOT CMAKE_GENERATOR MATCHES "Visual Studio")
  list(APPEND example_directories
    use_component_depsA
    use_component_depsB
    use_component_depsC
  )
endif()

# test to see if we have programs necessary to run codecheck
include(IgnCodeCheck)
ign_setup_target_for_codecheck()

foreach(example ${example_directories})
  set(run_codecheck false)
  if (${example} STREQUAL "ign_configure_build")
    set(example_tarball_name ignition-minimal-0.1.0.tar.bz2)
  elseif (${example} STREQUAL "prerelease")
    set(example_tarball_name ignition-minimal-1.0.0~pre1.tar.bz2)
  elseif (${example} STREQUAL "core_no_deps")
    set(example_tarball_name ignition-core_no_deps-0.1.0.tar.bz2)
    set(run_codecheck true)
  elseif (${example} STREQUAL "core_child")
    set(example_tarball_name ignition-core_child-0.1.0.tar.bz2)
    set(run_codecheck true)
  elseif (${example} STREQUAL "component_deps")
    set(example_tarball_name ignition-component_deps-0.1.0.tar.bz2)
  elseif (${example} STREQUAL "use_component_depsA")
    set(example_tarball_name ignition-use_component_depsa-0.1.0.tar.bz2)
  elseif (${example} STREQUAL "use_component_depsB")
    set(example_tarball_name ignition-use_component_depsb-0.1.0.tar.bz2)
  elseif (${example} STREQUAL "use_component_depsC")
    set(example_tarball_name ignition-use_component_depsc-0.1.0.tar.bz2)
  else()
    set(example_tarball_name)
  endif()

  foreach (build_type ${build_types})
    set(TEST_NAME ${example}_${build_type})
    string(TIMESTAMP TEST_TIME)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/junit_pass.xml.in"
      "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}_pass.xml"
      @ONLY)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/junit_fail.xml.in"
      "${CMAKE_CURRENT_BINARY_DIR}/test_results/${TEST_NAME}.xml"
      @ONLY)
    set(example_INSTALL_DIR ${CMAKE_BINARY_DIR}/install/${build_type})
    ExternalProject_Add(
      ${TEST_NAME}

      DEPENDS FAKE_INSTALL
      SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${example}"
      # BUILD_ALWAYS needed since cmake doesn't notice when
      # example files change.
      # See alternate approach in a2113e0997c9 if this becomes too slow
      BUILD_ALWAYS 1
      CMAKE_ARGS
        "-DCMAKE_PREFIX_PATH=${FAKE_INSTALL_PREFIX};${example_INSTALL_DIR}"
        "-DCMAKE_BUILD_TYPE=${build_type}"
        "-DCMAKE_INSTALL_PREFIX=${example_INSTALL_DIR}"
      TEST_COMMAND
        ${CMAKE_COMMAND} -E copy
        "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}_pass.xml"
        "${CMAKE_CURRENT_BINARY_DIR}/test_results/${TEST_NAME}.xml"
    )
    if (${run_codecheck} AND TARGET codecheck)
      if(CMAKE_GENERATOR MATCHES "Unix Makefiles")
        ExternalProject_Add_Step(
          ${TEST_NAME}
          codecheck
          COMMAND
            $(MAKE) -C <BINARY_DIR> codecheck
          DEPENDEES
            configure
        )
      else()
        ExternalProject_Add_Step(
          ${TEST_NAME}
          codecheck
          COMMAND
            ${CMAKE_COMMAND} --build <BINARY_DIR> --target codecheck
          DEPENDEES
            configure
        )
      endif()
    endif()
    if (CPACK_GENERATOR)
      if(CMAKE_GENERATOR MATCHES "Unix Makefiles")
        ExternalProject_Add_Step(
          ${TEST_NAME}
          package_source
          COMMAND
            $(MAKE) -C <BINARY_DIR> package_source
          DEPENDEES
            configure
        )
      else()
        ExternalProject_Add_Step(
          ${TEST_NAME}
          package_source
          COMMAND
            ${CMAKE_COMMAND} --build <BINARY_DIR> --target package_source
          DEPENDEES
            configure
        )
      endif()

      ExternalProject_Add_Step(
        ${TEST_NAME}
        test_tarball_name
        COMMAND
          ${CMAKE_COMMAND} -E tar tf <BINARY_DIR>/${example_tarball_name}
        DEPENDEES
          package_source
        DEPENDERS
          test
      )
    endif()
    add_test(
      ${TEST_NAME}
      ${CMAKE_COMMAND} -E copy
      "${CMAKE_CURRENT_BINARY_DIR}/test_results/${TEST_NAME}.xml"
      "${CMAKE_BINARY_DIR}/test_results/${TEST_NAME}.xml"
    )
  endforeach()

endforeach()

# dependencies between external projects
# hard to use DEPENDS in ExternalProject_Add because targets
# need to exist before they can be used there
foreach (build_type ${build_types})
  add_dependencies(core_child_${build_type} core_no_deps_${build_type})
  if (TARGET use_component_depsA_${build_type})
    add_dependencies(use_component_depsA_${build_type} component_deps_${build_type})
  endif()
  if (TARGET use_component_depsB_${build_type})
    add_dependencies(use_component_depsB_${build_type} component_deps_${build_type})
  endif()
  if (TARGET use_component_depsC_${build_type})
    add_dependencies(use_component_depsC_${build_type} component_deps_${build_type})
  endif()
endforeach()

# test that core_child pkg-config file requires core_no_deps
if (UNIX)
  set(TEST_NAME core_child_requires_core_no_deps)
  string(TIMESTAMP TEST_TIME)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/junit_pass.xml.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}_pass.xml"
    @ONLY)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/junit_fail.xml.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}_fail.xml"
    @ONLY)
  set(_env_vars)
  list(APPEND _env_vars "PKG_CONFIG_PATH=${example_INSTALL_DIR}/lib/pkgconfig:${FAKE_INSTALL_PREFIX}/lib/pkgconfig:$PKG_CONFIG_PATH")
  add_test(${TEST_NAME}
    ${CMAKE_CURRENT_SOURCE_DIR}/test_core_child_requires_core_no_deps.bash
  )
  set_tests_properties(${TEST_NAME} PROPERTIES
    ENVIRONMENT "${_env_vars}")
endif()

=== examples/use_component_depsB/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
project(ignition-use_component_depsB VERSION 0.1.0)
find_package(ignition-cmake2 REQUIRED)
ign_configure_project()
ign_find_package(ignition-component_deps REQUIRED COMPONENTS child parent)
ign_configure_build(QUIT_IF_BUILD_ERRORS)
ign_create_packages()
ign_create_docs()

=== examples/use_component_depsC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
project(ignition-use_component_depsC VERSION 0.1.0)
find_package(ignition-cmake2 REQUIRED)
ign_configure_project()
ign_find_package(ignition-component_deps REQUIRED COMPONENTS child)
ign_configure_build(QUIT_IF_BUILD_ERRORS)
ign_create_packages()
ign_create_docs()

=== examples/core_no_deps/src/CMakeLists.txt ===
ign_get_libsources_and_unittests(sources gtest_sources)
ign_create_core_library(SOURCES ${sources} CXX_STANDARD 11)
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources})

=== examples/prerelease/src/CMakeLists.txt ===

ign_create_core_library(INTERFACE)

=== debian/changelog ===
ignition-cmake2 (2.1.1+dfsg-3) unstable; urgency=medium

  * Fix install file. Closes: #947441

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 10 Jan 2020 15:52:30 +0000

ignition-cmake2 (2.1.1+dfsg-2) unstable; urgency=medium

  [ Jose Luis Rivero ]
  * Use Comment tag in copyright
  * Do not to repack sources, tar.gz2 preferred

  [ Jochen Sprickerhof ]
  * Simplify comment in d/copyright

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 25 Dec 2019 22:33:23 +0100

ignition-cmake2 (2.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2.1.1
    (Closes: #944539)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 11 Nov 2019 15:46:23 +0000

=== debian/control ===
Source: ignition-cmake2
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               libjs-mathjax,
               libgtest-dev,
               pkg-config,
               python3
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/science-team/ignition-cmake2
Vcs-Git: https://salsa.debian.org/science-team/ignition-cmake2.git
Rules-Requires-Root: no
Homepage: http://ignitionrobotics.org/libraries/cmake

Package: libignition-cmake2-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}
Description: Ignition Robotics CMake Library - Development files
 CMake modules to be used by the Ignition projects.
 .
 This package is required to build ignition projects, as well as to link your
 third party projects against them. It provides modules that are used to find
 dependencies of ignition projects and generate cmake targets for consumers of
 ignition projects to link against.

=== debian/tests/control ===
Tests: build
Depends: libignition-cmake2-dev, cmake, g++, pkg-config

=== debian/watch ===
version=4
opts= dversionmangle=s/\+dfsg// \
  http://gazebosim.org/distributions/ign-cmake/releases/ .*ignition-cmake2-(\d\.\d\.\d)\.tar.bz2

## ignition-cmake2 2.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-cmake2 VERSION 2.1.1)
+project(ignition-cmake2 VERSION 2.9.0)
 
 #--------------------------------------
 # Initialize the IGNITION_CMAKE_DIR variable with the location of the cmake
@@ -20,7 +20,11 @@
 
 #--------------------------------------
 # Set up the project
-ign_configure_project()
+ign_configure_project(VERSION_SUFFIX)
+
+#--------------------------------------
+# Set project-specific options
+option(BUILDSYSTEM_TESTING "Enable extended buildsystem testing" FALSE)
 
 #--------------------------------------
 # Install the ignition documentation files
@@ -39,6 +43,10 @@
 install(DIRECTORY codecheck/
         DESTINATION ${IGN_DATA_INSTALL_DIR}/codecheck)
 
+#--------------------------------------
+# Install the tools files
+install(DIRECTORY tools/
+        DESTINATION ${IGN_DATA_INSTALL_DIR}/tools)
 
 #============================================================================
 # Configure the package to be installed
@@ -52,6 +60,7 @@
 set(ign_config_install_dir "${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME_LOWER}")
 set(ign_pkgconfig_input "${CMAKE_CURRENT_SOURCE_DIR}/config/ignition-cmake.pc.in")
 set(ign_pkgconfig_output "${CMAKE_BINARY_DIR}/ignition-cmake${PROJECT_VERSION_MAJOR}.pc")
+set(ign_pkgconfig_install_dir "${IGN_LIB_INSTALL_DIR}/pkgconfig")
 set(ign_utilities_target ${PROJECT_EXPORT_NAME}-utilities)
 set(ign_utilities_import_target_name ${PROJECT_EXPORT_NAME}::${ign_utilities_target})
 set(ign_utilities_target_output_filename "${ign_utilities_target}-targets.cmake")
@@ -82,11 +91,16 @@
 
 #--------------------------------------
 # Configure and install the pkgconfig file (needed for utilities headers)
+file(RELATIVE_PATH
+  IGN_PC_CONFIG_RELATIVE_PATH_TO_PREFIX
+  "${CMAKE_INSTALL_PREFIX}/${ign_pkgconfig_install_dir}"
+  "${CMAKE_INSTALL_PREFIX}"
+)
 configure_file(${ign_pkgconfig_input} ${ign_pkgconfig_output} @ONLY)
 
 install(
   FILES ${ign_pkgconfig_output}
-  DESTINATION ${IGN_LIB_INSTALL_DIR}/pkgconfig
+  DESTINATION ${ign_pkgconfig_install_dir}
   COMPONENT pkgconfig)
 
 #============================================================================
@@ -148,7 +162,9 @@
 include(CTest)
 if (BUILD_TESTING)
   add_subdirectory(test)
-
+endif()
+
+if (BUILD_TESTING AND BUILDSYSTEM_TESTING)
   #============================================================================
   # Build examples
   #============================================================================
@@ -176,3 +192,24 @@
 
   add_subdirectory(examples)
 endif()
+
+# Codecheck
+set(CPPCHECK_DIRS
+  ${CMAKE_SOURCE_DIR}/examples
+)
+set(CPPCHECK_INCLUDE_DIRS
+  ${CMAKE_SOURCE_DIR}/include
+  ${CMAKE_SOURCE_DIR}/examples
+)
+set(IGNITION_CMAKE_CODECHECK_DIR "${CMAKE_CURRENT_SOURCE_DIR}/codecheck")
+include(IgnCodeCheck)
+ign_setup_target_for_codecheck()
+
+# Docs
+set(IGNITION_CMAKE_DOXYGEN_DIR "${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen")
+configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
+configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)
+ign_create_docs(
+  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
+  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md"
+  )

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,5 @@
 include(ExternalProject)
+include(GNUInstallDirs)
 
 # test multiple build types
 set(build_types Release RelWithDebInfo Debug)
@@ -8,11 +9,12 @@
 endif()
 
 set(example_directories
-  ign_configure_build
+  ign_conf
   prerelease
-  core_no_deps
+  core_nodep
   core_child
-  component_deps
+  core_child_private
+  comp_deps
   )
 if (NOT CMAKE_GENERATOR MATCHES "Visual Studio")
   list(APPEND example_directories
@@ -22,23 +24,22 @@
   )
 endif()
 
-# test to see if we have programs necessary to run codecheck
-include(IgnCodeCheck)
-ign_setup_target_for_codecheck()
-
 foreach(example ${example_directories})
   set(run_codecheck false)
-  if (${example} STREQUAL "ign_configure_build")
+  if (${example} STREQUAL "ign_conf")
     set(example_tarball_name ignition-minimal-0.1.0.tar.bz2)
   elseif (${example} STREQUAL "prerelease")
     set(example_tarball_name ignition-minimal-1.0.0~pre1.tar.bz2)
-  elseif (${example} STREQUAL "core_no_deps")
+  elseif (${example} STREQUAL "core_nodep")
     set(example_tarball_name ignition-core_no_deps-0.1.0.tar.bz2)
     set(run_codecheck true)
   elseif (${example} STREQUAL "core_child")
     set(example_tarball_name ignition-core_child-0.1.0.tar.bz2)
     set(run_codecheck true)
-  elseif (${example} STREQUAL "component_deps")
+  elseif (${example} STREQUAL "core_child_private")
+    set(example_tarball_name ignition-core_child_private-0.1.0.tar.bz2)
+    set(run_codecheck true)
+  elseif (${example} STREQUAL "comp_deps")
     set(example_tarball_name ignition-component_deps-0.1.0.tar.bz2)
   elseif (${example} STREQUAL "use_component_depsA")
     set(example_tarball_name ignition-use_component_depsa-0.1.0.tar.bz2)
@@ -147,21 +148,23 @@
 # hard to use DEPENDS in ExternalProject_Add because targets
 # need to exist before they can be used there
 foreach (build_type ${build_types})
-  add_dependencies(core_child_${build_type} core_no_deps_${build_type})
+  add_dependencies(core_child_${build_type} core_nodep_${build_type})
+  add_dependencies(core_child_private_${build_type} core_nodep_${build_type})
   if (TARGET use_component_depsA_${build_type})
-    add_dependencies(use_component_depsA_${build_type} component_deps_${build_type})
+    add_dependencies(use_component_depsA_${build_type} comp_deps_${build_type})
   endif()
   if (TARGET use_component_depsB_${build_type})
-    add_dependencies(use_component_depsB_${build_type} component_deps_${build_type})
+    add_dependencies(use_component_depsB_${build_type} comp_deps_${build_type})
   endif()
   if (TARGET use_component_depsC_${build_type})
-    add_dependencies(use_component_depsC_${build_type} component_deps_${build_type})
+    add_dependencies(use_component_depsC_${build_type} comp_deps_${build_type})
   endif()
 endforeach()
 
-# test that core_child pkg-config file requires core_no_deps
+# test that core_child pkg-config file requires core_nodep
+# and that core_child_private pkg-config file requires core_nodep privately
 if (UNIX)
-  set(TEST_NAME core_child_requires_core_no_deps)
+  set(TEST_NAME core_child_requires_core_nodep)
   string(TIMESTAMP TEST_TIME)
   configure_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/junit_pass.xml.in"
@@ -172,7 +175,16 @@
     "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}_fail.xml"
     @ONLY)
   set(_env_vars)
-  list(APPEND _env_vars "PKG_CONFIG_PATH=${example_INSTALL_DIR}/lib/pkgconfig:${FAKE_INSTALL_PREFIX}/lib/pkgconfig:$PKG_CONFIG_PATH")
+  # On Debian and if the install prefix is /usr, the default CMAKE_INSTALL_LIBDIR of this project
+  # as set by GNUInstallDirs will be different from the one of the example project, 
+  # so let's hardcode it in that case
+  if(EXISTS "/etc/debian_version" AND "${CMAKE_INSTALL_PREFIX}" MATCHES "^/usr/?$")
+    set(example_PKGCONFIG_INSTALL_LIBDIR "lib/pkgconfig")
+  else()
+    set(example_PKGCONFIG_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
+  endif()
+
+  list(APPEND _env_vars "PKG_CONFIG_PATH=${example_INSTALL_DIR}/${example_PKGCONFIG_INSTALL_LIBDIR}:${FAKE_INSTALL_PREFIX}/${example_PKGCONFIG_INSTALL_LIBDIR}:$PKG_CONFIG_PATH")
   add_test(${TEST_NAME}
     ${CMAKE_CURRENT_SOURCE_DIR}/test_core_child_requires_core_no_deps.bash
   )

=== debian/changelog ===
ignition-cmake2 (2.9.0-1~buster) buster; urgency=medium

  * ignition-cmake2 2.9.0-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Thu, 02 Sep 2021 11:28:46 -0500

ignition-cmake2 (2.8.0-1~buster) buster; urgency=medium

  * ignition-cmake2 2.8.0-1 release

 -- Ashton Larkin <ashton@openrobotics.org>  Tue, 04 May 2021 11:30:43 -0600

ignition-cmake2 (2.7.0-1~buster) buster; urgency=medium

  * ignition-cmake2 2.7.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Tue, 30 Mar 2021 11:53:17 -0700

ignition-cmake2 (2.7.0~pre2-1~buster) buster; urgency=medium

  * ignition-cmake2 2.7.0~pre2-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 24 Mar 2021 17:00:29 -0700

ignition-cmake2 (2.7.0~pre1-1~buster) buster; urgency=medium

  * ignition-cmake2 2.7.0~pre1-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 04 Feb 2021 13:51:40 -0800

ignition-cmake2 (2.6.2-1~buster) buster; urgency=medium

  * ignition-cmake2 2.6.2-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 30 Dec 2020 10:07:21 -0800

ignition-cmake2 (2.6.1-1~buster) buster; urgency=medium

  * ignition-cmake2 2.6.1-1 release

 -- Ashton Larkin <ashton@openrobotics.org>  Thu, 10 Dec 2020 18:09:34 -0500

ignition-cmake2 (2.6.0-1~buster) buster; urgency=medium

  * ignition-cmake2 2.6.0-1 release

 -- Michael Carroll <michael@openrobotics.org>  Tue, 08 Dec 2020 11:21:43 -0600

ignition-cmake2 (2.5.0-1~buster) buster; urgency=medium

  * ignition-cmake2 2.5.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Tue, 08 Sep 2020 16:18:44 -0700

ignition-cmake2 (2.4.0-1~buster) buster; urgency=medium

  * ignition-cmake2 2.4.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 20 Aug 2020 17:47:57 -0700

ignition-cmake2 (2.3.0-1~buster) buster; urgency=medium

  * ignition-cmake2 2.3.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 07 Aug 2020 21:48:28 +0200

ignition-cmake2 (2.2.0-1~buster) buster; urgency=medium

  * ignition-cmake2 2.2.0-1 release

 -- Nate Koenig <nate@osrfoundation.org>  Mon, 06 Apr 2020 13:58:43 -0800

ignition-cmake2 (2.1.1-1~buster) buster; urgency=medium

  * ignition-cmake2 2.1.1-1 release

 -- Nate Koenig <nate@osrfoundation.org>  Wed, 07 Aug 2019 18:32:58 -0800

=== debian/control ===
Source: ignition-cmake2
Standards-Version: 3.9.5
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 9)
Vcs-Browser: https://bitbucket.org/ignitionrobotics/ign_cmake-release
Vcs-Hg: https://bitbucket.org/ignitionrobotics/ign_cmake-release
Homepage: http://ignitionrobotics.org/

Package: libignition-cmake2-dev
Architecture: any
Section: libdevel
Depends: cmake
Multi-Arch: same
Description: Ignition Robotics CMake Library - Development files

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

.PHONY: override_dh_auto_configure override_dh_auto_install

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
            -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_install:
	dh_auto_install
	# The test suite install artifacts on HOME/ that ended up on the binary.
	# Remove everything except usr/*
	find 'debian/libignition-cmake2-dev/' -mindepth 1 -maxdepth 1 ! -name 'usr' -type d -exec rm -rf {} +

## ignition-cmake2 2.15.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-cmake2 VERSION 2.9.0)
+project(ignition-cmake2 VERSION 2.15.0)
 
 #--------------------------------------
 # Initialize the IGNITION_CMAKE_DIR variable with the location of the cmake
@@ -20,7 +20,10 @@
 
 #--------------------------------------
 # Set up the project
-ign_configure_project(VERSION_SUFFIX)
+ign_configure_project(
+  REPLACE_IGNITION_INCLUDE_PATH gz/cmake
+  VERSION_SUFFIX
+)
 
 #--------------------------------------
 # Set project-specific options

=== debian/changelog ===
ignition-cmake2 (2.15.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.15.0-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Mon, 29 Aug 2022 16:21:32 -0700

ignition-cmake2 (2.14.0-2~focal) focal; urgency=medium

  * ignition-cmake2 2.14.0-2 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 12 Aug 2022 11:30:20 -0700

ignition-cmake2 (2.14.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.14.0-1 release

 -- Jenn Nguyen <jenn@openrobotics.org>  Mon, 25 Jul 2022 16:02:03 -0700

ignition-cmake2 (2.13.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.13.0-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Fri, 22 Jul 2022 13:58:22 -0700

ignition-cmake2 (2.12.1-1~focal) focal; urgency=medium

  * ignition-cmake2 2.12.1-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 12 Apr 2022 22:44:53 +0200

ignition-cmake2 (2.12.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.12.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 11 Apr 2022 21:07:00 +0200

ignition-cmake2 (2.12.0~pre1-1~focal) focal; urgency=medium

  * ignition-cmake2 2.12.0~pre1-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 08 Apr 2022 15:56:28 +0200

ignition-cmake2 (2.11.0-2~focal) focal; urgency=medium

  * ignition-cmake2 2.11.0-2 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 16 Mar 2022 12:28:51 +0100

ignition-cmake2 (2.11.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.11.0-1 release

 -- Michael Carroll <michael@openrobotics.org>  Wed, 23 Feb 2022 20:42:24 -0600

ignition-cmake2 (2.10.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.10.0-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Tue, 21 Dec 2021 23:03:40 -0800

ignition-cmake2 (2.10.0~pre3-1~focal) focal; urgency=medium

  * ignition-cmake2 2.10.0~pre3-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Mon, 20 Dec 2021 15:51:49 -0800

ignition-cmake2 (2.10.0~pre2-1~focal) focal; urgency=medium

  * ignition-cmake2 2.10.0~pre2-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Fri, 17 Dec 2021 10:08:03 -0800

ignition-cmake2 (2.10.0~pre1-1~focal) focal; urgency=medium

  * ignition-cmake2 2.10.0~pre1-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 09 Dec 2021 08:36:00 -0800

ignition-cmake2 (2.9.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.9.0-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Thu, 02 Sep 2021 11:28:46 -0500

ignition-cmake2 (2.8.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.8.0-1 release

 -- Ashton Larkin <ashton@openrobotics.org>  Tue, 04 May 2021 11:30:43 -0600

ignition-cmake2 (2.7.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.7.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Tue, 30 Mar 2021 11:53:16 -0700

ignition-cmake2 (2.7.0~pre2-1~focal) focal; urgency=medium

  * ignition-cmake2 2.7.0~pre2-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 24 Mar 2021 17:00:29 -0700

ignition-cmake2 (2.7.0~pre1-1~focal) focal; urgency=medium

  * ignition-cmake2 2.7.0~pre1-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 04 Feb 2021 13:51:39 -0800

ignition-cmake2 (2.6.2-1~focal) focal; urgency=medium

  * ignition-cmake2 2.6.2-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 30 Dec 2020 10:07:20 -0800

ignition-cmake2 (2.6.1-1~focal) focal; urgency=medium

  * ignition-cmake2 2.6.1-1 release

 -- Ashton Larkin <ashton@openrobotics.org>  Thu, 10 Dec 2020 18:09:34 -0500

ignition-cmake2 (2.6.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.6.0-1 release

 -- Michael Carroll <michael@openrobotics.org>  Tue, 08 Dec 2020 11:21:43 -0600

ignition-cmake2 (2.5.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.5.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Tue, 08 Sep 2020 16:18:44 -0700

ignition-cmake2 (2.4.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.4.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 20 Aug 2020 17:47:57 -0700

ignition-cmake2 (2.3.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.3.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 07 Aug 2020 21:48:28 +0200

ignition-cmake2 (2.2.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.2.0-1 release

 -- Nate Koenig <nate@osrfoundation.org>  Mon, 06 Apr 2020 13:58:43 -0800

=== debian/control ===
Source: ignition-cmake2
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 11)
Vcs-Browser: https://github.com/gazebosim/gz-cmake
Vcs-Git: https://github.com/gazebosim/gz-cmake.git
Standards-Version: 4.5.1
Homepage: http://gazebosim.org/

Package: libignition-cmake2-dev
Architecture: any
Section: libdevel
Depends: cmake, ${misc:Depends}
Multi-Arch: same
Description: Gazebo CMake Library - Development files
 CMake modules to be used by the Gazebo projects.
 .
 This package is required to build Gazebo projects, as well as to link your
 third party projects against them. It provides modules that are used to find
 dependencies of Gazebo projects and generate cmake targets for consumers of
 Gazebo projects to link against.

Package: libgz-cmake2-dev
Depends: libignition-cmake2-dev, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 It's recommended to use the gz packages going forward.

## ignition-cmake2 2.17.1

=== debian/changelog ===
ignition-cmake2 (2.17.1-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.17.1-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Thu, 31 Aug 2023 15:18:46 -0500

ignition-cmake2 (2.17.0-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.17.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 22 May 2023 11:46:56 +0200

ignition-cmake2 (2.16.0-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.16.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 10 Nov 2022 01:38:54 +0100

ignition-cmake2 (2.15.0-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.15.0-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Mon, 29 Aug 2022 16:21:32 -0700

ignition-cmake2 (2.14.0-2~jammy) jammy; urgency=medium

  * ignition-cmake2 2.14.0-2 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 12 Aug 2022 11:30:19 -0700

ignition-cmake2 (2.14.0-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.14.0-1 release

 -- Jenn Nguyen <jenn@openrobotics.org>  Mon, 25 Jul 2022 16:02:02 -0700

ignition-cmake2 (2.13.0-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.13.0-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Fri, 22 Jul 2022 13:58:22 -0700

ignition-cmake2 (2.12.1-2~jammy) jammy; urgency=medium

  * ignition-cmake2 2.12.1-2 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 11 May 2022 21:38:20 +0200

ignition-cmake2 (2.12.1-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.12.1-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 12 Apr 2022 22:44:52 +0200

ignition-cmake2 (2.12.0-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.12.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 11 Apr 2022 21:06:59 +0200

ignition-cmake2 (2.12.0~pre1-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.12.0~pre1-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 08 Apr 2022 15:56:27 +0200

ignition-cmake2 (2.11.0-2~jammy) jammy; urgency=medium

  * ignition-cmake2 2.11.0-2 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 16 Mar 2022 12:29:47 +0100

ignition-cmake2 (2.11.0-1~jammy) jammy; urgency=medium

  * ignition-cmake2 2.11.0-1 release

 -- Michael Carroll <michael@openrobotics.org>  Wed, 23 Feb 2022 20:42:23 -0600

ignition-cmake2 (2.10.0-99~jammy) jammy; urgency=medium

  * ignition-cmake2 2.10.0-99 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 15 Feb 2022 19:30:27 +0100

ignition-cmake2 (2.10.0-1~jammy) jammy; urgency=medium

  * First release for jammy

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 14 Jan 2022 19:12:08 +0100

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,9 @@
 Architecture: any
 Section: libdevel
 Depends: cmake, ${misc:Depends}
+Breaks: libignition-cmake-dev (<= 2.10.0-2)
+Replaces: libignition-cmake-dev (<= 2.10.0-2)
+Provides: libignition-cmake-dev (= ${binary:Version})
 Multi-Arch: same
 Description: Gazebo CMake Library - Development files
  CMake modules to be used by the Gazebo projects.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

.PHONY: override_dh_auto_configure override_dh_auto_install

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
            -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_install:
	# Remove artifacts installed by testing
	dh_auto_install
	find . -type d -name install | xargs rm -rf
	find . -type d -empty -delete

=== debian/tests/control ===
Tests: build
Depends: @, cmake, g++, pkg-config

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/gazebosim/gz-cmake/tags \
		(?:.*?/)@PACKAGE@.*_(\d[\d.]*)\.tar\.gz

## ignition-cmake2 2.17.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-cmake2 VERSION 2.15.0)
+project(ignition-cmake2 VERSION 2.17.2)
 
 #--------------------------------------
 # Initialize the IGNITION_CMAKE_DIR variable with the location of the cmake
@@ -63,7 +63,7 @@
 set(ign_config_install_dir "${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME_LOWER}")
 set(ign_pkgconfig_input "${CMAKE_CURRENT_SOURCE_DIR}/config/ignition-cmake.pc.in")
 set(ign_pkgconfig_output "${CMAKE_BINARY_DIR}/ignition-cmake${PROJECT_VERSION_MAJOR}.pc")
-set(ign_pkgconfig_install_dir "${IGN_LIB_INSTALL_DIR}/pkgconfig")
+set(ign_pkgconfig_install_dir "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")
 set(ign_utilities_target ${PROJECT_EXPORT_NAME}-utilities)
 set(ign_utilities_import_target_name ${PROJECT_EXPORT_NAME}::${ign_utilities_target})
 set(ign_utilities_target_output_filename "${ign_utilities_target}-targets.cmake")
@@ -96,9 +96,17 @@
 # Configure and install the pkgconfig file (needed for utilities headers)
 file(RELATIVE_PATH
   IGN_PC_CONFIG_RELATIVE_PATH_TO_PREFIX
-  "${CMAKE_INSTALL_PREFIX}/${ign_pkgconfig_install_dir}"
+  "${ign_pkgconfig_install_dir}"
   "${CMAKE_INSTALL_PREFIX}"
 )
+
+# TODO(jrivero): CMake 3.20 provides cmake_path(APPEND) which implements the
+# same functionality as join_paths(). Remove JoinPaths in the next major version
+# if all the supported platforms are in 3.20 version.
+include(JoinPaths)
+join_paths(IGN_PC_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")
+join_paths(IGN_PC_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}" "${IGN_INCLUDE_INSTALL_DIR_POSTFIX}")
+
 configure_file(${ign_pkgconfig_input} ${ign_pkgconfig_output} @ONLY)
 
 install(

=== debian/changelog ===
ignition-cmake2 (2.17.2-1~focal) focal; urgency=medium

  * ignition-cmake2 2.17.2-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 08 May 2024 15:44:45 +0200

ignition-cmake2 (2.17.1-1~focal) focal; urgency=medium

  * ignition-cmake2 2.17.1-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Thu, 31 Aug 2023 15:18:45 -0500

ignition-cmake2 (2.17.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.17.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 22 May 2023 11:46:56 +0200

ignition-cmake2 (2.16.0-1~focal) focal; urgency=medium

  * ignition-cmake2 2.16.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 10 Nov 2022 01:38:54 +0100
